//Fluchtdiagramm für die Standardmap
//Es kommt wegen der multithreaded Graphic zu einigen wenigen Pixelfehlern
//////////////////////////////////////////////////////////////////////////////////
public class MyThread extends Thread {  
  double xmin,ymin;
  color farbe;
  PGraphics pg;
 
  double massFuerUnendlich;
  double x0,y0,xAlt,yAlt,xNeu,yNeu;
  double wh;
  double K;
  protected boolean running = false;
  

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public MyThread(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, double KFaktor) {
    // benötigte Parameter
    K = KFaktor;
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    pg = createGraphics(width,height/anzahlThreads);
    
  }

 //////////////////////////////////////////////////////////////  
  public void run() {
    
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
       // println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println("y: "+ymin,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j = 0; j < pg.height; j++) {
          double x = xmin;
          for (int i = 0; i < pg.width; i++) {
            double D = standardMapIteration(x, y);
            pg.pixels[i+j*pg.width] = colorize(D); 
          
          //  if (((y<=0) && (y+dy >0)|| (x<=3) && (x+dx>3) ))
           //   pg.pixels[i+j*pg.width] = color(0,0,50,100); //x-und y-Achse   
            x += dx;
          }   
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  
/////////////////////////////////////////////////////////////////////
double standardMapIteration(double xH, double yH) {

  //Standardmap Algorithmus zur Berechung des Abstand des Originalpunktes zum Punkt nach einer Iterationen
 
  double d = 0;
  x0 = xH; y0=yH;

  xAlt = xH; yAlt = yH;
 //Der Wertebereich wird nicht auf den Definitionbereich eingeschränkt, weil sonst der Abstand zwischen 
 //Startpunkt und erster Iteration unsinnige Werte, rechnet man mit modulo,  ergeben kann 
  yNeu = (yAlt + K*Math.sin(xAlt)) ;
  xNeu = (xAlt + yNeu) ; 

  d = Math.sqrt((x0-xNeu)*(x0-xNeu)+(y0-yNeu)*(y0-yNeu)); 
       
  d = 64*d; 

  return d;
 }
/////////////////////////////////////////////////////////////
color colorize(double dist) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
   color col; 
      dist = dist%256;
      col = color((int)(dist+128)%255,(int)(6*dist)%255,(int)(12*dist)%255); 
      //if(dist ==0) col = color(255); else
       //col = color((int)(dist),255,255); 
    return col; 
  
 }
}
