//////////////////////////////////////////////////////////////////
//Fluchtdiagramm der Standardmap
//Methode: Es wird nur der Abstand des ersten Iterationspunktes
//zum urprünglichen Punkt farblich codiert.
//Bis zu 1 000 000 -fache Vergrößerungen sind möglich
/////////////////////////////////////////////////////////////////

ArrayList<MyThread> workers;
double xmin = 0; 
double ymin = -3; 
double wh = 6;
int maxiterations = 20; 
double massFuerUnendlich = 1000;
int anzahlThreads = Runtime.getRuntime().availableProcessors();//Bild ohne Math.PIxelfehler wähle anzahlThreads =1
double K = 0.971635;
//double K = 1.2;
PImage bild, bildGedreht;
int vFaktor = 15  ;
 double xSpecial , ySpecial;

void setup() {
  background(255);
  colorMode(HSB);
  workers = new  ArrayList<MyThread>(); 
  size(800, 800);
  println("Anzahl Threads: "+anzahlThreads);
  starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);
 
  bild = createImage(width,height,HSB);
  bildGedreht = createImage(width,height,HSB);
}
////////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh){
  
  xmin = px; ymin = py;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;
  for (double y= ymin; y<(ymin+wh); y=y+wh/anzahlThreads) {
        MyThread t = new MyThread(xmin,y,maxiterations,massFuerUnendlich,wh/anzahlThreads,K);
        workers.add(t);
        t.start();  
        delay(50);//einzelne Math.PIxelfehler sind so sehr selten
   }  
}


//////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(MyThread t: workers){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i =0; i< workers.size(); i++){
    image(workers.get(i).pg,0,i*height/anzahlThreads);
    
  }  
  //Initialisierung der Math.PImages
   bild = get();
   bildGedreht = get();
   //weil negativer y-Bereich bisher oben ist SMath.PIegelung an x-Achse
 
   for (int i = 0; i < bildGedreht.width; i++){
      for (int j = 0; j < bildGedreht.height; j++) {
           bildGedreht.set(i,j,bild.get(i,bild.height-j-1));
      }
    }
    image(bildGedreht,0,0);
   
   noLoop();    
}

/////////////////////////////////////////////////////////////////
void mousePressed() {
   println("Vergrößerung: "+vFaktor+"-fach"); vFaktor = 2*vFaktor;
   workers = new  ArrayList<MyThread>(); 
  // berechne, wo der Mauszeiger im gezeigten Ausschnitt der 
  // Zahlenebene ist (Transformation Math.PIxelposition nach (x,y))
  double x = xmin + wh*mouseX/width;
  double y = ymin + wh*(height-mouseY)/height;//negativer y-Wert muss unten sein
  //println(x,y);
  // linke Maustaste: verkleinere den gezeigten Ausschnitt um 0.5
  // rechte Taste: vergrößere den gezeigten Ausschnitt entsprechend
  if (mouseButton == LEFT) wh*=0.5; 
  else wh/=0.5;

  // bestimme den neuen gezeigten Ausschnitt
  xmin = x-wh/2.0;
  ymin = y-wh/2.0;
  starteThreads(xmin, ymin, maxiterations, massFuerUnendlich, wh);

  redraw();
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
 
  if (key == 's') save("standardMapFlucht.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
